"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = cannyEdge;
var _cannyEdgeDetector = _interopRequireDefault(require("canny-edge-detector"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
/**
 * @memberof Image
 * @instance
 * @param {object} [options]
 * @param {number} [options.gaussianBlur=1.1] - Sigma parameter for the gaussian filter step
 * @param {number} [options.lowThreshold=10] - Low threshold for the hysteresis procedure
 * @param {number} [options.highThreshold=30] - High threshold for the hysteresis procedure
 * @return {Image}
 */
function cannyEdge(options) {
  return (0, _cannyEdgeDetector.default)(this, options);
}