"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = extend;
var _matchAndCrop = _interopRequireDefault(require("./transform/matchAndCrop"));
var _min = _interopRequireDefault(require("./compute/min"));
var _max = _interopRequireDefault(require("./compute/max"));
var _median = _interopRequireDefault(require("./compute/median"));
var _histogram = _interopRequireDefault(require("./compute/histogram"));
var _histograms = _interopRequireDefault(require("./compute/histograms"));
var _averageImage = _interopRequireDefault(require("./utility/averageImage"));
var _maxImage = _interopRequireDefault(require("./utility/maxImage"));
var _minImage = _interopRequireDefault(require("./utility/minImage"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
/* eslint-disable import/order */

function extend(Stack) {
  // let inPlace = {inPlace: true};
  Stack.extendMethod('matchAndCrop', _matchAndCrop.default);
  Stack.extendMethod('getMin', _min.default);
  Stack.extendMethod('getMax', _max.default);
  Stack.extendMethod('getMedian', _median.default);
  Stack.extendMethod('getHistogram', _histogram.default);
  Stack.extendMethod('getHistograms', _histograms.default);
  Stack.extendMethod('getAverage', _averageImage.default); // to be removed but will be a breaking change

  Stack.extendMethod('getAverageImage', _averageImage.default);
  Stack.extendMethod('getMaxImage', _maxImage.default);
  Stack.extendMethod('getMinImage', _minImage.default);
}